//+------------------------------------------------------------------+
//|                                                         Test.mq5 |
//|                        Copyright 2019, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2019, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property version   "1.00"

#include <CList.mqh>
#include <CObject.mqh>
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
class CTest:public CObject
  {
   int               m_a;
public:
                     CTest(int m):m_a(m){Print("Construct: ",m_a);}
                    ~CTest() {Print("Delete: ",m_a);}
   int                Get() {return m_a;}
  };
//+------------------------------------------------------------------+
//| Script program start function                                    |
//+------------------------------------------------------------------+
void OnStart()
  {
   CList<CTest> test;
   CTest *temp=NULL;
   Print("-----START------");
   for(int i=0;i<3;test.PushBack(new CTest(i++)));
   Print("List size: ",test.GetSize());
   Print("Current position: ",test.GetIterator());
   Print("First object: ",test.Begine().Get());
   Print ("Last object: ",test.End().Get());
   Print("Object at position 1: ",test[1].Get());
   Print("Push object at position 1: ",test.Push(new CTest(100),1).Get());
   Print("Push object at first position: ",test.PushFirst(new CTest(10)).Get());
   Print ("Push object at last position: ",test.PushBack(new CTest(20)).Get());
   temp=test.Swap(new CTest(30),3);
   Print("Swap object at position 3, old object: ",temp.Get());
   delete temp;
   Print("Insert object at position 4: ",test.Insert(new CTest(40),4).Get());
   Print("List:");
   Print (test.Begine().Get());
   while(!test.IsLast()) Print(test.Next().Get());
   Print("Revers List:");
   Print (test.End().Get());
   while(!test.IsFirst()) Print(test.Prev().Get());
   temp=test.Move(2);
   Print("Move object from position 2, old object: ",temp.Get());
   delete temp;
   temp=test.PopFirst();
   Print("Pop first object, old first object: ",temp.Get());
   delete temp;
   temp=test.PopBack();
   Print("Pop last object, old last object: ",temp.Get());
   delete temp;
   Print("Erace object from positon 1: ",test.Erace(1).Get()); //Leaked memory
   Print("Delete object from positon 1: ",test.Delete(1).Get());
   Print("List:");
   Print (test.Begine().Get());
   while(!test.IsLast()) Print(test.Next().Get());   
  }
//+------------------------------------------------------------------+
